diff --git a/configure b/configure
index 5b4e828b81..5270388e5c 100755
--- a/configure
+++ b/configure
@@ -643,6 +643,7 @@ infodir
 docdir
 oldincludedir
 includedir
+runstatedir
 localstatedir
 sharedstatedir
 sysconfdir
@@ -720,6 +721,7 @@ datadir='${datarootdir}'
 sysconfdir='${prefix}/etc'
 sharedstatedir='${prefix}/com'
 localstatedir='${prefix}/var'
+runstatedir='${localstatedir}/run'
 includedir='${prefix}/include'
 oldincludedir='/usr/include'
 docdir='${datarootdir}/doc/${PACKAGE_TARNAME}'
@@ -972,6 +974,15 @@ do
   | -silent | --silent | --silen | --sile | --sil)
     silent=yes ;;
 
+  -runstatedir | --runstatedir | --runstatedi | --runstated \
+  | --runstate | --runstat | --runsta | --runst | --runs \
+  | --run | --ru | --r)
+    ac_prev=runstatedir ;;
+  -runstatedir=* | --runstatedir=* | --runstatedi=* | --runstated=* \
+  | --runstate=* | --runstat=* | --runsta=* | --runst=* | --runs=* \
+  | --run=* | --ru=* | --r=*)
+    runstatedir=$ac_optarg ;;
+
   -sbindir | --sbindir | --sbindi | --sbind | --sbin | --sbi | --sb)
     ac_prev=sbindir ;;
   -sbindir=* | --sbindir=* | --sbindi=* | --sbind=* | --sbin=* \
@@ -1109,7 +1120,7 @@ fi
 for ac_var in	exec_prefix prefix bindir sbindir libexecdir datarootdir \
 		datadir sysconfdir sharedstatedir localstatedir includedir \
 		oldincludedir docdir infodir htmldir dvidir pdfdir psdir \
-		libdir localedir mandir
+		libdir localedir mandir runstatedir
 do
   eval ac_val=\$$ac_var
   # Remove trailing slashes.
@@ -1262,6 +1273,7 @@ Fine tuning of the installation directories:
   --sysconfdir=DIR        read-only single-machine data [PREFIX/etc]
   --sharedstatedir=DIR    modifiable architecture-independent data [PREFIX/com]
   --localstatedir=DIR     modifiable single-machine data [PREFIX/var]
+  --runstatedir=DIR       modifiable per-process data [LOCALSTATEDIR/run]
   --libdir=DIR            object code libraries [EPREFIX/lib]
   --includedir=DIR        C header files [PREFIX/include]
   --oldincludedir=DIR     C header files for non-gcc [/usr/include]
diff --git a/docs/configure b/docs/configure
index a5780d9942..fb346dd787 100755
--- a/docs/configure
+++ b/docs/configure
@@ -634,6 +634,7 @@ infodir
 docdir
 oldincludedir
 includedir
+runstatedir
 localstatedir
 sharedstatedir
 sysconfdir
@@ -710,6 +711,7 @@ datadir='${datarootdir}'
 sysconfdir='${prefix}/etc'
 sharedstatedir='${prefix}/com'
 localstatedir='${prefix}/var'
+runstatedir='${localstatedir}/run'
 includedir='${prefix}/include'
 oldincludedir='/usr/include'
 docdir='${datarootdir}/doc/${PACKAGE_TARNAME}'
@@ -962,6 +964,15 @@ do
   | -silent | --silent | --silen | --sile | --sil)
     silent=yes ;;
 
+  -runstatedir | --runstatedir | --runstatedi | --runstated \
+  | --runstate | --runstat | --runsta | --runst | --runs \
+  | --run | --ru | --r)
+    ac_prev=runstatedir ;;
+  -runstatedir=* | --runstatedir=* | --runstatedi=* | --runstated=* \
+  | --runstate=* | --runstat=* | --runsta=* | --runst=* | --runs=* \
+  | --run=* | --ru=* | --r=*)
+    runstatedir=$ac_optarg ;;
+
   -sbindir | --sbindir | --sbindi | --sbind | --sbin | --sbi | --sb)
     ac_prev=sbindir ;;
   -sbindir=* | --sbindir=* | --sbindi=* | --sbind=* | --sbin=* \
@@ -1099,7 +1110,7 @@ fi
 for ac_var in	exec_prefix prefix bindir sbindir libexecdir datarootdir \
 		datadir sysconfdir sharedstatedir localstatedir includedir \
 		oldincludedir docdir infodir htmldir dvidir pdfdir psdir \
-		libdir localedir mandir
+		libdir localedir mandir runstatedir
 do
   eval ac_val=\$$ac_var
   # Remove trailing slashes.
@@ -1252,6 +1263,7 @@ Fine tuning of the installation directories:
   --sysconfdir=DIR        read-only single-machine data [PREFIX/etc]
   --sharedstatedir=DIR    modifiable architecture-independent data [PREFIX/com]
   --localstatedir=DIR     modifiable single-machine data [PREFIX/var]
+  --runstatedir=DIR       modifiable per-process data [LOCALSTATEDIR/run]
   --libdir=DIR            object code libraries [EPREFIX/lib]
   --includedir=DIR        C header files [PREFIX/include]
   --oldincludedir=DIR     C header files for non-gcc [/usr/include]
diff --git a/stubdom/configure b/stubdom/configure
index 8e6e0542be..c4130dc1fd 100755
--- a/stubdom/configure
+++ b/stubdom/configure
@@ -587,6 +587,7 @@ PACKAGE_URL='http://www.xen.org/'
 ac_unique_file="xenstore-minios.cfg"
 ac_subst_vars='LTLIBOBJS
 LIBOBJS
+STUBDOM_UNINSTALL
 STUBDOM_INSTALL
 STUBDOM_BUILD
 STUBDOM_TARGETS
@@ -659,6 +660,7 @@ infodir
 docdir
 oldincludedir
 includedir
+runstatedir
 localstatedir
 sharedstatedir
 sysconfdir
@@ -748,6 +750,7 @@ datadir='${datarootdir}'
 sysconfdir='${prefix}/etc'
 sharedstatedir='${prefix}/com'
 localstatedir='${prefix}/var'
+runstatedir='${localstatedir}/run'
 includedir='${prefix}/include'
 oldincludedir='/usr/include'
 docdir='${datarootdir}/doc/${PACKAGE_TARNAME}'
@@ -1000,6 +1003,15 @@ do
   | -silent | --silent | --silen | --sile | --sil)
     silent=yes ;;
 
+  -runstatedir | --runstatedir | --runstatedi | --runstated \
+  | --runstate | --runstat | --runsta | --runst | --runs \
+  | --run | --ru | --r)
+    ac_prev=runstatedir ;;
+  -runstatedir=* | --runstatedir=* | --runstatedi=* | --runstated=* \
+  | --runstate=* | --runstat=* | --runsta=* | --runst=* | --runs=* \
+  | --run=* | --ru=* | --r=*)
+    runstatedir=$ac_optarg ;;
+
   -sbindir | --sbindir | --sbindi | --sbind | --sbin | --sbi | --sb)
     ac_prev=sbindir ;;
   -sbindir=* | --sbindir=* | --sbindi=* | --sbind=* | --sbin=* \
@@ -1137,7 +1149,7 @@ fi
 for ac_var in	exec_prefix prefix bindir sbindir libexecdir datarootdir \
 		datadir sysconfdir sharedstatedir localstatedir includedir \
 		oldincludedir docdir infodir htmldir dvidir pdfdir psdir \
-		libdir localedir mandir
+		libdir localedir mandir runstatedir
 do
   eval ac_val=\$$ac_var
   # Remove trailing slashes.
@@ -1290,6 +1302,7 @@ Fine tuning of the installation directories:
   --sysconfdir=DIR        read-only single-machine data [PREFIX/etc]
   --sharedstatedir=DIR    modifiable architecture-independent data [PREFIX/com]
   --localstatedir=DIR     modifiable single-machine data [PREFIX/var]
+  --runstatedir=DIR       modifiable per-process data [LOCALSTATEDIR/run]
   --libdir=DIR            object code libraries [EPREFIX/lib]
   --includedir=DIR        C header files [PREFIX/include]
   --oldincludedir=DIR     C header files for non-gcc [/usr/include]
@@ -1984,6 +1997,7 @@ ioemu=y
 STUBDOM_TARGETS="$STUBDOM_TARGETS ioemu"
 STUBDOM_BUILD="$STUBDOM_BUILD ioemu-stubdom"
 STUBDOM_INSTALL="$STUBDOM_INSTALL install-ioemu"
+STUBDOM_UNINSTALL="$STUBDOM_UNINSTALL install-ioemu"
 
 
 else
@@ -2014,6 +2028,7 @@ c=y
 STUBDOM_TARGETS="$STUBDOM_TARGETS c"
 STUBDOM_BUILD="$STUBDOM_BUILD c-stubdom"
 STUBDOM_INSTALL="$STUBDOM_INSTALL install-c"
+STUBDOM_UNINSTALL="$STUBDOM_UNINSTALL install-c"
 
 
 else
@@ -2051,6 +2066,7 @@ caml=y
 STUBDOM_TARGETS="$STUBDOM_TARGETS caml"
 STUBDOM_BUILD="$STUBDOM_BUILD caml-stubdom"
 STUBDOM_INSTALL="$STUBDOM_INSTALL install-caml"
+STUBDOM_UNINSTALL="$STUBDOM_UNINSTALL install-caml"
 
 
 else
@@ -2088,6 +2104,7 @@ grub=y
 STUBDOM_TARGETS="$STUBDOM_TARGETS grub"
 STUBDOM_BUILD="$STUBDOM_BUILD pv-grub"
 STUBDOM_INSTALL="$STUBDOM_INSTALL install-grub"
+STUBDOM_UNINSTALL="$STUBDOM_UNINSTALL install-grub"
 
 
 else
@@ -2110,6 +2127,7 @@ grub=y
 STUBDOM_TARGETS="$STUBDOM_TARGETS grub"
 STUBDOM_BUILD="$STUBDOM_BUILD pv-grub"
 STUBDOM_INSTALL="$STUBDOM_INSTALL install-grub"
+STUBDOM_UNINSTALL="$STUBDOM_UNINSTALL install-grub"
 
 
 fi
@@ -2128,6 +2146,7 @@ xenstore=y
 STUBDOM_TARGETS="$STUBDOM_TARGETS xenstore"
 STUBDOM_BUILD="$STUBDOM_BUILD xenstore-stubdom"
 STUBDOM_INSTALL="$STUBDOM_INSTALL install-xenstore"
+STUBDOM_UNINSTALL="$STUBDOM_UNINSTALL install-xenstore"
 
 
 else
@@ -2150,6 +2169,7 @@ xenstore=y
 STUBDOM_TARGETS="$STUBDOM_TARGETS xenstore"
 STUBDOM_BUILD="$STUBDOM_BUILD xenstore-stubdom"
 STUBDOM_INSTALL="$STUBDOM_INSTALL install-xenstore"
+STUBDOM_UNINSTALL="$STUBDOM_UNINSTALL install-xenstore"
 
 
 fi
@@ -2168,6 +2188,7 @@ vtpm=y
 STUBDOM_TARGETS="$STUBDOM_TARGETS vtpm"
 STUBDOM_BUILD="$STUBDOM_BUILD vtpm-stubdom"
 STUBDOM_INSTALL="$STUBDOM_INSTALL install-vtpm"
+STUBDOM_UNINSTALL="$STUBDOM_UNINSTALL install-vtpm"
 
 
 else
@@ -2198,6 +2219,7 @@ vtpmmgr=y
 STUBDOM_TARGETS="$STUBDOM_TARGETS vtpmmgr"
 STUBDOM_BUILD="$STUBDOM_BUILD vtpmmgr-stubdom"
 STUBDOM_INSTALL="$STUBDOM_INSTALL install-vtpmmgr"
+STUBDOM_UNINSTALL="$STUBDOM_UNINSTALL install-vtpmmgr"
 
 
 else
@@ -3577,6 +3599,7 @@ vtpm=y
 STUBDOM_TARGETS="$STUBDOM_TARGETS vtpm"
 STUBDOM_BUILD="$STUBDOM_BUILD vtpm-stubdom"
 STUBDOM_INSTALL="$STUBDOM_INSTALL install-vtpm"
+STUBDOM_UNINSTALL="$STUBDOM_UNINSTALL install-vtpm"
 
 
 else
@@ -3596,6 +3619,7 @@ vtpmmgr=y
 STUBDOM_TARGETS="$STUBDOM_TARGETS vtpmmgr"
 STUBDOM_BUILD="$STUBDOM_BUILD vtpmmgr-stubdom"
 STUBDOM_INSTALL="$STUBDOM_INSTALL install-vtpmmgr"
+STUBDOM_UNINSTALL="$STUBDOM_UNINSTALL install-vtpmmgr"
 
 
 else
@@ -3615,6 +3639,7 @@ ioemu=y
 STUBDOM_TARGETS="$STUBDOM_TARGETS ioemu"
 STUBDOM_BUILD="$STUBDOM_BUILD ioemu-stubdom"
 STUBDOM_INSTALL="$STUBDOM_INSTALL install-ioemu"
+STUBDOM_UNINSTALL="$STUBDOM_UNINSTALL install-ioemu"
 
 
 else
@@ -3631,6 +3656,7 @@ fi
 
 
 
+
 echo "Will build the following stub domains:"
 for x in $STUBDOM_BUILD; do
 	echo "  $x"
diff --git a/tools/configure b/tools/configure
index c8da3fe62a..29393a3ad2 100755
--- a/tools/configure
+++ b/tools/configure
@@ -769,6 +769,7 @@ infodir
 docdir
 oldincludedir
 includedir
+runstatedir
 localstatedir
 sharedstatedir
 sysconfdir
@@ -892,6 +893,7 @@ datadir='${datarootdir}'
 sysconfdir='${prefix}/etc'
 sharedstatedir='${prefix}/com'
 localstatedir='${prefix}/var'
+runstatedir='${localstatedir}/run'
 includedir='${prefix}/include'
 oldincludedir='/usr/include'
 docdir='${datarootdir}/doc/${PACKAGE_TARNAME}'
@@ -1144,6 +1146,15 @@ do
   | -silent | --silent | --silen | --sile | --sil)
     silent=yes ;;
 
+  -runstatedir | --runstatedir | --runstatedi | --runstated \
+  | --runstate | --runstat | --runsta | --runst | --runs \
+  | --run | --ru | --r)
+    ac_prev=runstatedir ;;
+  -runstatedir=* | --runstatedir=* | --runstatedi=* | --runstated=* \
+  | --runstate=* | --runstat=* | --runsta=* | --runst=* | --runs=* \
+  | --run=* | --ru=* | --r=*)
+    runstatedir=$ac_optarg ;;
+
   -sbindir | --sbindir | --sbindi | --sbind | --sbin | --sbi | --sb)
     ac_prev=sbindir ;;
   -sbindir=* | --sbindir=* | --sbindi=* | --sbind=* | --sbin=* \
@@ -1281,7 +1292,7 @@ fi
 for ac_var in	exec_prefix prefix bindir sbindir libexecdir datarootdir \
 		datadir sysconfdir sharedstatedir localstatedir includedir \
 		oldincludedir docdir infodir htmldir dvidir pdfdir psdir \
-		libdir localedir mandir
+		libdir localedir mandir runstatedir
 do
   eval ac_val=\$$ac_var
   # Remove trailing slashes.
@@ -1434,6 +1445,7 @@ Fine tuning of the installation directories:
   --sysconfdir=DIR        read-only single-machine data [PREFIX/etc]
   --sharedstatedir=DIR    modifiable architecture-independent data [PREFIX/com]
   --localstatedir=DIR     modifiable single-machine data [PREFIX/var]
+  --runstatedir=DIR       modifiable per-process data [LOCALSTATEDIR/run]
   --libdir=DIR            object code libraries [EPREFIX/lib]
   --includedir=DIR        C header files [PREFIX/include]
   --oldincludedir=DIR     C header files for non-gcc [/usr/include]